@echo off
setlocal enabledelayedexpansion

set "bin_path=out\s100"

if "%~1" == "" (
    echo Usage: %~nx0 MCU_IMAGE_NAME
    echo Example: %~nx0 MCU_S100_V1.0.img
    exit
)

set "mcu_img=%~1%"

echo ------------ start download hsm ------------
dfu-util -d,3652:6610 -a 0 -D "%bin_path%\cmd_load_hsmfw"
dfu-util -d,3652:6610 -a 0 -D "%bin_path%\hsmfw_se.pkg"
dfu-util -d,3652:6610 -a 0 -D "%bin_path%\cmd_exit_hsmfw"
echo waiting for hsm start...
ping -n 5 127.0.0.1 >nul

echo ------------ start download sbl ------------
dfu-util -d,3652:6615 -a 0 -D "%bin_path%\fpt.img" -R
ping -n 3 127.0.0.1 >nul
dfu-util -d,3652:6615 -a 0 -D "%bin_path%\keyimage.img" -R
ping -n 3 127.0.0.1 >nul
dfu-util -d,3652:6615 -a 0 -D "%bin_path%\SBL.img" -R
ping -n 3 127.0.0.1 >nul
dfu-util -d,3652:6615 -a 0 -D "%bin_path%\hsmrca.pkg" -R
echo waiting for sbl start...
ping -n 5 127.0.0.1 >nul


echo ------------ start download spl ------------
dfu-util -d,3652:6620 -a 0 -D "%bin_path%\spl.img" -R
echo waiting for spl start...
ping -n 3 127.0.0.1 >nul

echo ------------ start download mcu ------------
dfu-util -d,3652:6620 -a 0 -D "%bin_path%\%mcu_img%" -R
echo waiting for mcu start...
ping -n 20 127.0.0.1 >nul

echo ------------ start download bl31 optee uboot ------------
dfu-util -d,3652:6625 -a 0 -D "%bin_path%\acore_cfg.img"
dfu-util -d,3652:6625 -a 1 -D "%bin_path%\bl31.img"
dfu-util -d,3652:6625 -a 2 -D "%bin_path%\optee.img"
dfu-util -d,3652:6625 -a 3 -D "%bin_path%\uboot.img" -R

echo ------------ download all success, start uboot... ------------

:end
endlocal
